//+------------------------------------------------------------------+
//|                                               KeltnerChannel.mq4 |
//|                                              Copyleft ***  2006 |
//|                                  http://http://www.forex-tsd.com |
//+------------------------------------------------------------------+
#property copyright "***"
#property link      "http://www.forex-tsd.com"

//---- input parameters

extern int     BigMA_Period = 216;
extern int     Env_Period = 60;
extern double  Env_deviation = 0.4;
extern int     TradeType = 1; // 1 - Scalping, stop trailing to channel centre line
                              // 2 - Swing trade, stop trailing to Big Moving Average
extern int     Move_SL_to_breakeven = 1; //1 - yes, 0 - no
extern double  Lots=0.1;

extern int     magic=1111;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  int Env_ma_method = 0;
  int BigMA_method = 0;
   //MODE_SMA 0 Simple moving average, 
   //MODE_EMA 1 Exponential moving average, 
   //MODE_SMMA 2 Smoothed moving average, 
   //MODE_LWMA 3 Linear weighted moving average.

  int Env_applied_price = 5;
  int BigMA_applied_price = 5;
   //PRICE_CLOSE 0 Close price. 
   //PRICE_OPEN 1 Open price. 
   //PRICE_HIGH 2 High price. 
   //PRICE_LOW 3 Low price. 
   //PRICE_MEDIAN 4 Median price, (high+low)/2. 
   //PRICE_TYPICAL 5 Typical price, (high+low+close)/3. 
   //PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 

  
  
  
//----

int cmd = 2; double price; int slippage = 4; double stoploss; double takeprofit; color colour;
bool myTrades;
int myTicket;
static datetime myTime;
static int FirstSLmove = 0;
static double StopLevel;
double TrailingStop;

StopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL);

for(int i=0;i<OrdersTotal();i++)
{
   if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
      {
         myTrades = true;
         myTicket = OrderTicket();
      }
}

   double EnvHigh = iEnvelopes(NULL, 0, Env_Period, Env_ma_method, 0, Env_applied_price, Env_deviation, MODE_UPPER, 0);
   double EnvLow = iEnvelopes(NULL, 0, Env_Period, Env_ma_method, 0, Env_applied_price, Env_deviation, MODE_LOWER, 0);
   double EnvCentre = iMA(NULL, 0, Env_Period, 0, Env_ma_method, Env_applied_price, 0);
   double BigMA = iMA(NULL, 0, BigMA_Period, 0, BigMA_method, BigMA_applied_price, 0);

   if(myTrades == false)
   {
      if(Bid > EnvHigh && EnvCentre >= BigMA)
      {
         cmd = 0; price = Ask; colour = Green; stoploss = NormalizeDouble(EnvCentre,Digits); takeprofit = 0; 
         
      }

      if(Bid < EnvLow && EnvCentre <= BigMA)
      {
         cmd = 1; price = Bid; colour = Red; stoploss = NormalizeDouble(EnvCentre,Digits); takeprofit = 0;
      }

      if(cmd != 2)
      {
         OrderSend(Symbol(), cmd, Lots, price, slippage, stoploss, takeprofit, NULL, magic, 0, colour) ;
         FirstSLmove = Move_SL_to_breakeven;
      }
   }

   if(myTrades == true)
   {
      OrderSelect(myTicket, SELECT_BY_TICKET, MODE_TRADES);
      
      if(FirstSLmove == 1) 
      {
         if(OrderType() == 1 && OrderStopLoss() > EnvCentre && EnvCentre <= OrderOpenPrice()) // && UpModify != 1) // || (OrderType() == 1 && OrderStopLoss() > EnvCentre)) 
         { stoploss = NormalizeDouble(EnvCentre,Digits); }   
         
         if(OrderType() == 0 && OrderStopLoss() < EnvCentre && EnvCentre >= OrderOpenPrice()) // && UpModify != 1) // || (OrderType() == 1 && OrderStopLoss() > EnvCentre)) 
         { stoploss = NormalizeDouble(EnvCentre,Digits); } 
         
         if(stoploss != 0)
         {
            OrderModify(myTicket, OrderOpenPrice(), stoploss, OrderTakeProfit(), 0, Yellow);
            FirstSLmove = 0;
         }
      } else {

         if(TradeType == 1) TrailingStop = EnvCentre;
         if(TradeType == 2) TrailingStop = BigMA;

         if(OrderType() == 1 && OrderStopLoss() > TrailingStop && TrailingStop > Ask + (1 + StopLevel) * Point)
         { stoploss = NormalizeDouble(TrailingStop,Digits); }   
         
         if(OrderType() == 0 && OrderStopLoss() < TrailingStop && TrailingStop < Bid - (1 + StopLevel) * Point) 
         { stoploss = NormalizeDouble(TrailingStop,Digits); } 
         
         if(stoploss != 0)
         { OrderModify(myTicket, OrderOpenPrice(), stoploss, OrderTakeProfit(), 0, Yellow); }
   
      }
   
   }

   

//----
   return(0);
  }
//+------------------------------------------------------------------+